//////////////////////////////////////////////////////////////////////////////
// DCMO5.H - declarations communes pour dcmo5
// Author   : Daniel Coulom - danielcoulom@gmail.com
// Web site : http://dcmo5.free.fr
// Created  : October 2008
// Last updated : 2008-10-25
//
// This file is part of DCMO5 v11.
// 
// DCMO5 v11 is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// DCMO5 v11 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with DCMO5 v11.  If not, see <http://www.gnu.org/licenses/>.
//
//////////////////////////////////////////////////////////////////////////////

#define KEYBOARDKEY_MAX 58    //nombre de touches du clavier MO5
#define JOYSTICKKEY_MAX 10    //nombre total de contacts des deux manettes 
#define KEYBOARDBUTTON_MAX 60 //nombre de boutons boite de dialogue clavier 
#define JOYSTICKBUTTON_MAX 12 //nombre de boutons boite de dialogue manettes 
#define STATUSBUTTON_MAX 5    //nombre de boutons de la barre de statut 
#define OPTIONBUTTON_MAX 13   //nombre de boutons boite de dialogue options 
#define DESASSBUTTON_MAX 10   //nombre de boutons boite de dialogue desass 
#define LANGUAGE_MAX 2        //nombre de langues differentes 
#define MSG_MAX 50            //nombre de textes dans chaque langue 
#define BOUTON_MAX 78         //nombre de boutons differents clavier

typedef struct  //structure 'dialogbutton' 
{
 int x;         //ordonnee du coin haut-gauche
 int y;         //abscisse du coin haut-gauche
 int n;         //numero de la surface SDL
} dialogbutton;

typedef struct  //structure 'bouton'
{
 char name[12]; //nom du bouton
 int w;         //largeur en pixels
 int h;         //hauteur en pixels
} button;


/* Memory access function definition *****************************************/
//external functions (or pointers to functions)
//memory is accessed through :
//Mgetc : reads one byte from address a
//Mputc : writes one byte to address a
char (*Mgetc)(unsigned short);       //pointer to function
void (*Mputc)(unsigned short, char); //pointer to function
//Mgetw : reads two bytes from address a
//Mputw : writes two bytes to address a
short Mgetw(unsigned short a);
void Mputw(unsigned short a, short w);

/* Pointeur fonction de chargement de fichier ********************************/
void (*Load[3])(char *name);

/* Function needing SDL include **********************************************/
#ifdef _SDL_H
void Drawtextbox(SDL_Surface *surf, char *string, SDL_Rect rect, int c);
#endif

/* Other function definition *************************************************/
void About();
void Clavier();
void Createdialogbox(int w, int h);
int Dasm6809(char *string, int a);
void Desass();
void Desassclick();
void Dialogmove();
void Displayline(int);
void Displayscreen();
void Drawdirlistbox(int);
void Drawk7index();
void Drawmenubox();
void Drawmessagebox(char *titre, char *text1[], char *text2[]);
void Drawoptionbox();
void Drawstatusbar();
void exit(int n);
void Erreur(int n);
void Formatdisk();
void Hardreset();
void Imprime();
void Info(int i);
void Init6809registerpointers();
void Initbuttonsurfaces();
void Initfilenames();
void Initoptions();
void Initpalette();
void Initprog();
void Initsdlttf();
void Initstatusbar();
void Irq();
void Joyclick();
void Joysemul(int i, int state);
void Keyboard();
void Keyboardinit();
void Keyclick();
void Keydown(int keysym, int scancode);
void Keyup(int keysym, int scancode);
void Manettes();
void Menuclick();
void Mouseclick();
void Nextmemo();
void Options();
void Optionclick();
void Readbitk7();
void Readoctetk7();
void Readpenxy();
void Readsector();
void Resizescreen(int x, int y);
int Run(int n);
int Run6809();
void Saveoptions();
void SDL_error(int n);
void Testshiftkey();
void Writeoctetk7();
void Writesector();
